// -*- mode: Java; file-coding-system: *euc-japan*; -*-
// $Id: EncodedData.java,v 1.1 1999/09/21 13:56:32 maeda Exp $
// Copyright (C) 1999 MAEDA Atusi

package jp.ac.tohoku.is.archi.mpi2.util;

import mpi.Datatype;

public interface EncodedData {
  /**
   * MPI.BYTEまたはMPI.DOUBLEを返す。
   */
  public Datatype type();

  /**
   * バッファ配列(byte[]またはdouble[])を返す。
   */
  public Object getArray();

  /**
   * バッファ配列の長さを返す。
   */
  public int length();

  /**
   * バッファ配列に書き込むための{@link Encoder}を返す。
   */
  public Encoder getEncoder();

  /**
   * バッファ配列から読み出すための{@link Decoder}を返す。
   */
  public Decoder getDecoder();
}
